package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * UpdateSsidDhcpOptionOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class UpdateSsidDhcpOptionOpenApiVo   {
  @JsonProperty("dhcpEnable")
  private Boolean dhcpEnable;

  @JsonProperty("format")
  private Integer format;

  @JsonProperty("delimiter")
  private String delimiter;

  @JsonProperty("circuitId")
  @Valid
  private List<Integer> circuitId = null;

  @JsonProperty("remoteId")
  @Valid
  private List<Integer> remoteId = null;

  public UpdateSsidDhcpOptionOpenApiVo dhcpEnable(Boolean dhcpEnable) {
    this.dhcpEnable = dhcpEnable;
    return this;
  }

  /**
   * SSID DHCP Option 82 global config status. True: enable, false: disable.
   * @return dhcpEnable
  */
  @ApiModelProperty(required = true, value = "SSID DHCP Option 82 global config status. True: enable, false: disable.")
  @NotNull


  public Boolean getDhcpEnable() {
    return dhcpEnable;
  }

  public void setDhcpEnable(Boolean dhcpEnable) {
    this.dhcpEnable = dhcpEnable;
  }

  public UpdateSsidDhcpOptionOpenApiVo format(Integer format) {
    this.format = format;
    return this;
  }

  /**
   * SSID DHCP Option 82 format config; It should be a value as follows: 0: ASCII; 1: Binary.
   * @return format
  */
  @ApiModelProperty(value = "SSID DHCP Option 82 format config; It should be a value as follows: 0: ASCII; 1: Binary.")


  public Integer getFormat() {
    return format;
  }

  public void setFormat(Integer format) {
    this.format = format;
  }

  public UpdateSsidDhcpOptionOpenApiVo delimiter(String delimiter) {
    this.delimiter = delimiter;
    return this;
  }

  /**
   * SSID DHCP Option 82 delimiter config (A single arbitrary ASCII character is acceptable).
   * @return delimiter
  */
  @ApiModelProperty(value = "SSID DHCP Option 82 delimiter config (A single arbitrary ASCII character is acceptable).")

@Pattern(regexp="^[\\040-\\0176]$") 
  public String getDelimiter() {
    return delimiter;
  }

  public void setDelimiter(String delimiter) {
    this.delimiter = delimiter;
  }

  public UpdateSsidDhcpOptionOpenApiVo circuitId(List<Integer> circuitId) {
    this.circuitId = circuitId;
    return this;
  }

  public UpdateSsidDhcpOptionOpenApiVo addCircuitIdItem(Integer circuitIdItem) {
    if (this.circuitId == null) {
      this.circuitId = new ArrayList<>();
    }
    this.circuitId.add(circuitIdItem);
    return this;
  }

  /**
   * SSID DHCP Option 82 Circuit-ID config. Circuit-ID is an array formed in the selected order, with each array element corresponding to the following enumeration values: 1: VLAN-ID; 2: AP Radio Mac-Address; 3: SSID-Type; 4: SSID-Name; 5: AP Ethernet MAC address; 6: Site-Name. As in the example [3,1,2,4], the following enumeration values are selected sequentially on the page: SSID-Type, VLAN-ID, AP Radio Mac-Address and SSID-Name.
   * @return circuitId
  */
  @ApiModelProperty(value = "SSID DHCP Option 82 Circuit-ID config. Circuit-ID is an array formed in the selected order, with each array element corresponding to the following enumeration values: 1: VLAN-ID; 2: AP Radio Mac-Address; 3: SSID-Type; 4: SSID-Name; 5: AP Ethernet MAC address; 6: Site-Name. As in the example [3,1,2,4], the following enumeration values are selected sequentially on the page: SSID-Type, VLAN-ID, AP Radio Mac-Address and SSID-Name.")


  public List<Integer> getCircuitId() {
    return circuitId;
  }

  public void setCircuitId(List<Integer> circuitId) {
    this.circuitId = circuitId;
  }

  public UpdateSsidDhcpOptionOpenApiVo remoteId(List<Integer> remoteId) {
    this.remoteId = remoteId;
    return this;
  }

  public UpdateSsidDhcpOptionOpenApiVo addRemoteIdItem(Integer remoteIdItem) {
    if (this.remoteId == null) {
      this.remoteId = new ArrayList<>();
    }
    this.remoteId.add(remoteIdItem);
    return this;
  }

  /**
   * SSID DHCP Option 82 Remote-ID config. Remote-ID is an array formed in the selected order, with each array element corresponding to the following enumeration values: 1: VLAN-ID; 2: AP Radio Mac-Address; 3: SSID-Type; 4: SSID-Name; 5: AP Ethernet MAC address; 6: Site-Name. As in the example [3,1,2,4], the following enumeration values are selected sequentially on the page: SSID-Type, VLAN-ID, AP Radio Mac-Address and SSID-Name.
   * @return remoteId
  */
  @ApiModelProperty(value = "SSID DHCP Option 82 Remote-ID config. Remote-ID is an array formed in the selected order, with each array element corresponding to the following enumeration values: 1: VLAN-ID; 2: AP Radio Mac-Address; 3: SSID-Type; 4: SSID-Name; 5: AP Ethernet MAC address; 6: Site-Name. As in the example [3,1,2,4], the following enumeration values are selected sequentially on the page: SSID-Type, VLAN-ID, AP Radio Mac-Address and SSID-Name.")


  public List<Integer> getRemoteId() {
    return remoteId;
  }

  public void setRemoteId(List<Integer> remoteId) {
    this.remoteId = remoteId;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UpdateSsidDhcpOptionOpenApiVo updateSsidDhcpOptionOpenApiVo = (UpdateSsidDhcpOptionOpenApiVo) o;
    return Objects.equals(this.dhcpEnable, updateSsidDhcpOptionOpenApiVo.dhcpEnable) &&
        Objects.equals(this.format, updateSsidDhcpOptionOpenApiVo.format) &&
        Objects.equals(this.delimiter, updateSsidDhcpOptionOpenApiVo.delimiter) &&
        Objects.equals(this.circuitId, updateSsidDhcpOptionOpenApiVo.circuitId) &&
        Objects.equals(this.remoteId, updateSsidDhcpOptionOpenApiVo.remoteId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(dhcpEnable, format, delimiter, circuitId, remoteId);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UpdateSsidDhcpOptionOpenApiVo {\n");
    
    sb.append("    dhcpEnable: ").append(toIndentedString(dhcpEnable)).append("\n");
    sb.append("    format: ").append(toIndentedString(format)).append("\n");
    sb.append("    delimiter: ").append(toIndentedString(delimiter)).append("\n");
    sb.append("    circuitId: ").append(toIndentedString(circuitId)).append("\n");
    sb.append("    remoteId: ").append(toIndentedString(remoteId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

